package djmil.cordacheckers.cordaclient.dao;

import java.io.Serializable;

import javax.naming.InvalidNameException;
import javax.naming.ldap.LdapName;
import javax.naming.ldap.Rdn;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;

@JsonIgnoreProperties(ignoreUnknown = true)
public record HoldingIdentity(String x500Name, String shortHash) implements Serializable {

    public String getName() throws InvalidNameException {
        LdapName ln = new LdapName(x500Name);

        for(Rdn rdn : ln.getRdns()) {
            if(rdn.getType().equalsIgnoreCase("CN")) {
                return rdn.getValue().toString();
            }
        }

        throw new IllegalArgumentException("CN not found: "+ x500Name);
    }

    public boolean isPlayer() throws InvalidNameException {
        LdapName ln = new LdapName(x500Name);

        for(Rdn rdn : ln.getRdns()) {
            if(rdn.getType().equalsIgnoreCase("OU")) {
                return rdn.getValue().toString().equalsIgnoreCase("Player");
            }
        }

        return false;
    }

    public boolean isCustodian() throws InvalidNameException {
        LdapName ln = new LdapName(x500Name);

        for(Rdn rdn : ln.getRdns()) {
            if(rdn.getType().equalsIgnoreCase("OU")) {
                return rdn.getValue().toString().equalsIgnoreCase("Custodian");
            }
        }

        return false;
    }

    public boolean isCordaCheckers() throws InvalidNameException {
        LdapName ln = new LdapName(x500Name);

        for(Rdn rdn : ln.getRdns()) {
            if(rdn.getType().equalsIgnoreCase("O")) {
                return rdn.getValue().toString().equalsIgnoreCase("Checkers");
            }
        }

        return false;
    }
}
